from gpiozero import MCP3008
from time import sleep, strftime, time

resistor_value = 670

def read_val():
    # reading from eTape sensor and storing resistance
    adc = MCP3008(channel=0, device=0)
    reading = float(adc.value * 1023)
    voltage = reading / 1023 * 3.3

    if voltage < 3.3:
        resistance = (voltage * resistor_value) / (3.3 - voltage)
    else:
        resistance = 0

    return reading, voltage, resistance

def log_data(v, r):
    # write voltage and  resistance
    with open("/home/pi/monitor_log.csv", "a") as log:
        log.write("{0},{1},{2},{3}\n".format("Date","        Time","       Voltage","      Resistance"))
        log.write("{0},{1},{2}\n".format(strftime("%Y-%m-%d   %H:%M:%S"), "   "+str("{:0f}".format(v)), "     "+str("{:0f}".format(r))))
        log.write("\n")

while True:
    reading, voltage, resistance = read_val()
    log_data(voltage, resistance)

    print("Raw Value: ", '{:0f}'.format(reading))
    print("Voltage: ", voltage)
    print("Resistance: ", '{:0f}'.format(resistance))
    print("\n")

    sleep(2)
